<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;

use Carbon\Carbon;
use App\Http\Providers\iam\core\model\OracleOCIConnector;
use App\Http\Base\BaseModel;

class ItemcategoryModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "itemcategory";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "itemCategory";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "category", "date_updated"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "itemCategory.id",
        "category" => "itemCategory.category",
    ];

    /**
     * relation from ' . Rolecategory . ' by ' . roleId
     * join users on users.id = itemCategory.roleId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationRoleCategory($alias = "roleCategory")
    {
        $this->getQuery()->join("rolecategory as $alias", "$alias.categoryId", "=", "itemCategory.id");
        return $this;
    }

    public function joinRelationRoleId($alias = "roleId", $alias2 = "roleCategory")
    {
        $this->getQuery()->join("rolecategory as ". $alias2, $alias2 . ".lokasiId", "=", "lokasiitem.id")
                        ->join("roles as $alias", $alias . ".id", "=", $alias2 . ".roleId");
        return $this;
    }


    public function syncFromOracleHO($syncTable)
    {
        (new LogsyncoracleModel)->setLogSync("Master Item Category", Carbon::now()->toDateTimeString(), "", "start");
        echo "start sync item category data from oracle", PHP_EOL;
        $oracleOCI = new OracleOCIConnector();
        $oracleOCI->getConnection()->select(self::getOracleQuery($syncTable, 0, 0))->execute();
        $lastUpdate = $syncTable->last_sync;
        while (($rows = $oracleOCI->fetchAll()) !== false) {
            $item = new self();
            $item->storingDataFromOracle($rows);
            if (!empty($rows->LAST_UPDATE_DATE)) $lastUpdate = $rows->LAST_UPDATE_DATE;
            $syncTable = \App\Http\Models\SyncUtilities\StagingSyncTableModel::find($syncTable->id);
            $syncTable->last_sync = $lastUpdate;
            $syncTable->update();
            

        }
        (new LogsyncoracleModel)->setLogSync("Master Item Category", Carbon::now()->toDateTimeString(), "", "success");
        $oracleOCI->closeConnection();

    }


    public static function getOracleQuery($staging, $startRow, $endRow)
    {
        $query = "SELECT DISTINCT ITEMV.TYPE_ID, ITEMV.ITEM_TYPE
                    FROM pelni_scm_items_v ITEMV
                    ORDER BY ITEMV.TYPE_ID ASC";
        return $query;
    }


    public function mapperOracle($oracle)
    {
        $this->id = $oracle->TYPE_ID;
        $this->category = $oracle->ITEM_TYPE;
    }

    public function storingDataFromOracle($oracle)
    {
        $oracle->TYPE_ID = intval($oracle->TYPE_ID);
            if($oracle->TYPE_ID > 0) {
            $itemExist = (new self())->getQuery()->where("itemCategory.id", "=", $oracle->TYPE_ID)->first();
            if ($itemExist) {
                $model = self::find($itemExist->id);
                try {
                    $model->mapperOracle($oracle);
                    $model->update();
                    echo $model->category . " " . $this->getTable() . "updated ", PHP_EOL;
                    (new LogsyncoracleModel)->setLogSync("Master Item Category - ".$oracle->TYPE_ID." - ".$oracle->ITEM_TYPE, Carbon::now()->toDateTimeString(), "", "updated");
                } catch (\Exception $exception) {
                    echo $oracle->ITEM_TYPE . " " . $exception->getMessage(), PHP_EOL;
                    (new LogsyncoracleModel)->setLogSync("Master Item Category - ".$oracle->TYPE_ID." - ".$oracle->ITEM_TYPE, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                }
            } else {
                try {
                    $model = new self();
                    $model->mapperOracle($oracle);
                    $model->save();
                    echo $model->category . " " . $this->getTable() . "inserted ", PHP_EOL;
                    (new LogsyncoracleModel)->setLogSync("Master Item Category - ".$oracle->TYPE_ID." - ".$oracle->ITEM_TYPE, Carbon::now()->toDateTimeString(), "", "inserted");
                } catch (\Exception $exception) {
                    echo $oracle->ITEM_TYPE . " " . $exception->getMessage(), PHP_EOL;
                    (new LogsyncoracleModel)->setLogSync("Master Item Category - ".$oracle->TYPE_ID." - ".$oracle->ITEM_TYPE, Carbon::now()->toDateTimeString(), $exception->getMessage(), "failed");
                }
            }
        }
    }

    public static function storeFromHO($data)
    {

        $model = (new self())->getQuery()->where("itemCategory.id", "=", $data->id)->first();
        if ($model) {
            $model = self::find($model->id);
            $model->id = $data->id;
            $model->category = $data->category;
            $model->date_updated = $data->date_updated;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Item Category - ".$data->id." - ".$data->category, Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
            $model->id = $data->id;
            $model->category = $data->category;
            $model->date_updated = $data->date_updated;
            $model->save([], $data->id, 0);
            (new LogsynckapalModel)->setLogSync("Item Category - ".$data->id." - ".$data->category, Carbon::now()->toDateTimeString(), "", "inserted");
        }
        echo $data->category . " sync", PHP_EOL;
    }

    public static function getItemCategory()
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_itemcategory";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 18)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Item Category HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {
                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $lastUpdate = !empty($syncTable->last_sync) ? \Carbon\Carbon::parse($syncTable->last_sync)->toAtomString() : $lastUpdate;
                $url = $url . "?date_updated=" . $lastUpdate . "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        if($page == 1) {
                            \App\Http\Models\ItemcategoryModel::truncate();
                        }
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\ItemcategoryModel::storeFromHO($item);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find(18);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else $fetch = false;

                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Item Category HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Item Category HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }
}